import pandas as pd
import requests
import json
from pandas.io.json import json_normalize
import numpy as np
import matplotlib.pyplot as plt
from mpl_toolkits.mplot3d import Axes3D
from sklearn.cluster import KMeans
from sklearn.decomposition import PCA
from sklearn.metrics import silhouette_samples, silhouette_score
import matplotlib.cm as cm
from sklearn.preprocessing import StandardScaler
import seaborn as sns
from pandas.plotting import scatter_matrix
from datetime import datetime
from collections import Counter
import plotly
plotly.offline.init_notebook_mode()

## get page list
with open('C:/Users/heyu/PycharmProjects/fullPageTitleList.json') as jsonFile:
    pageTitles = json.load(jsonFile)  # read json file
df = pd.DataFrame(pageTitles)  # turn into dataframe
pageList = df['0'].values  # turn into list
print(len(pageList))

## get visitor id list
baseurl = "https://empress.clai.io:1342/index.php?"
token = "&format=JSON&token_auth=92ff8605e20332d73e812cb23865a3bd"
module = "module=API&"
idSite = "1"  # don't change - there's only one page

method = "UserId.getUsers"

endpoint = baseurl + module + "method="+method+"&idSite="+idSite+"&period=year&date=2018-04-16"+token
token = 'dXNlcjpaRHNFaDlaVGdiSzJ4cWE4Z1pFQnZnN1BQNGR1a0U='
headers = {"Authorization":"Basic " + token}
#print(endpoint)

data = pd.DataFrame(requests.get(endpoint,headers=headers).json())

# use visitor name and id to create a 2D list
Id = data['idvisitor'].values
name = data['label'].values
allVisitorId = [[0]*2 for a in range(len(Id))]
for i in range(len(Id)):
    allVisitorId[i] = [name[i],Id[i]]

# only use study users ans test users
studyUsersName = ['tfs_aud_02','tfs_berit_05','tfs_jan_01','tfs_jorgen_07','tfs_karen_04','tfs_lill_03','tfs_line_08','tfs_oystein_09','tfs_steinar_06','tfs_thor_11','tsf_tone_10']
testUsersName = ['kay','ilya','stewart','td','sadiq','louise','malene','paul_mail_test_no','kerstin','keba_en','karenw','karen','charlotte','nirmalie','jan','agnar','amar','annelovise_no','Tom_TR_Test']
usersName = studyUsersName + testUsersName

visitorId = []
for i in range(len(allVisitorId)):
    if(allVisitorId[i][0] in usersName):
        visitorId.append(allVisitorId[i])

visitorId.sort()  # arrange visitors according to alpgabets
print(visitorId)
print(len(visitorId))

## get each visitor's 10 sessions
baseurl = "https://empress.clai.io:1342/index.php?"
token = "&format=JSON&token_auth=92ff8605e20332d73e812cb23865a3bd"
module = "module=API&"
idSite = "1"  # don't change - there's only one page

method = "Live.getVisitorProfile"

endpoint = ['0'] * len(visitorId)
for i in range(len(visitorId)):
    endpoint[i] = baseurl + module + "method="+method+"&idSite="+idSite+"&visitorId="+visitorId[i][1]+"&period=range&date=2018-04-16,2018-05-20"+token
token = 'dXNlcjpaRHNFaDlaVGdiSzJ4cWE4Z1pFQnZnN1BQNGR1a0U='
headers = {"Authorization":"Basic " + token}

flow_pca_list = []
time_matrix = []
user_totalVisits = []
for x in endpoint:
    data_raw = requests.get(x,headers=headers).json()
# get visit logs for all sessions and put them into a 2D array
    lastVisits = data_raw['lastVisits']  # details of all sessions
    totalVisits = data_raw['totalVisits']  # the number of sessions
    if(totalVisits > 10):
        totalVisits = 10
    user_totalVisits.append(totalVisits)

    visitDetailNorm = [0] * totalVisits
    actionsNum = [0] * totalVisits
    userflow = []
    for i in range(totalVisits):
        visitDetailNorm[i] = json_normalize(lastVisits[i])  # normalize each session
        actionsNum[i] = visitDetailNorm[i]['actions']  # the number of urls visited in each session
        pageTitle = []
        for j in range(int(actionsNum[i])):
            pageTitle.append(visitDetailNorm[i]['actionDetails'][0][j]['url'])  # put urls in all sessions in one array
        userflow.append(pageTitle)  # form a 2D array on the base on the 1D arrays
    # remove prefix of each url
    substr1 = 'http://com.selfback'
    substr2 = 'http://selfback/screen'
    for a in range(totalVisits):
        for b in range(len(userflow[a])):
            if(substr1 in str(userflow[a][b])):
                index = userflow[a][b].find(substr1)
                userflow[a][b] = userflow[a][b][index+len(substr1):]
            elif(substr2 in str(userflow[a][b])):
                index = userflow[a][b].find(substr2)
                userflow[a][b] = userflow[a][b][index+len(substr2):]        

    # remove the suffix of each url
    substr3 = '/selfback.EducationalQuiz/'
    substr4 = '/selfback.Exercise/'
    for a in range(totalVisits):
        for b in range(len(userflow[a])):
            if(substr3 in str(userflow[a][b])):
                index = userflow[a][b].find(substr3)
                userflow[a][b] = userflow[a][b][:index+len(substr3)-1]
            elif(substr4 in str(userflow[a][b])):
                index = userflow[a][b].find(substr4)
                userflow[a][b] = userflow[a][b][:index+len(substr4)-1]
    
    timespent_list = []
    for i in range(totalVisits):
        visitDetailNorm[i] = json_normalize(lastVisits[i])  # normalize each session
        actionsNum[i] = visitDetailNorm[i]['actions']  # the number of urls visited in each session
        timeSpent = []
        for j in range(int(actionsNum[i])):
            if('timeSpent' in visitDetailNorm[i]['actionDetails'][0][j]):
                timeSpent.append(int(visitDetailNorm[i]['actionDetails'][0][j]['timeSpent']))
            else:
                timeSpent.append(0)
        timespent_list.append(timeSpent)  # form a 2D array on the base on the 1D arrays

# put index of each page in each session in a 2D list
# get the max number of actions in all sessions
    max_actions = 0
    for i in range(totalVisits):
        if(int(actionsNum[i])>max_actions):
            max_actions = int(actionsNum[i])

# use the max_actions to initiate the index_list
    index_list = [[0]*max_actions for a in range(totalVisits)]  # index_list is totalVisits * len(each session) 2D list
    for m in pageList:
        for n in range(totalVisits):
            for p in range(len(userflow[n])):
                if(m == userflow[n][p]):
                    index1 = list(pageList).index(m)
                    index_list[n][p] = index1

    # remove the unnecessary index 0
    for i in range(totalVisits):
        num_0 = max_actions - int(actionsNum[i])
        for c in range(num_0):
            index_list[i].pop()

    # create a big list to put 10 matrix of each visitor
    user_index = endpoint.index(x)
    # create a 2D matrix for each session with the length of pageList and fill in 1s in the position referred by each index
    for i in range(totalVisits):
        flow_matrix = [[0]*len(pageList) for a in range(len(pageList))]  # flow_matrix is a 2D matrix with length of page list
    # check if there is only 1 index in the index_list[i]
        if(len(index_list[i])==1):
            flow_matrix[index_list[i][0]][index_list[i][0]] = 1
        else:
            for j in range(len(index_list[i])-1):
                if(flow_matrix[index_list[i][j]][index_list[i][j+1]] > 0):
                    flow_matrix[index_list[i][j]][index_list[i][j+1]] += 1  # if there is 1 at the position already, increase it to 2, and so on.
                else:
                    flow_matrix[index_list[i][j]][index_list[i][j+1]] = 1  # if there is 0 at the position, increase it to 1
        
        # apply pca to flow matrix
        pca = PCA(n_components=1)
        principalComponents0 = pca.fit_transform(flow_matrix)
        df0 = pd.DataFrame(data = principalComponents0)
        flow_pca = df0[0].values.tolist()  # 1 dimension list
        flow_pca_list.append(flow_pca)  # 2 dimension list
        
    index_matrix = []
    timespent_matrix = []
    for i in range(totalVisits):
        index_matrix += index_list[i]
        timespent_matrix += timespent_list[i]
        time_list = [0]*len(pageList)
        for j in range(len(index_matrix)):              
            if(time_list[index_matrix[j]]>0):
                time_list[index_matrix[j]] += timespent_matrix[j]
            else:
                time_list[index_matrix[j]] = timespent_matrix[j]  # 1 dimension list
        time_matrix.append(time_list)  # 2 dimension list
        
# apply pca to flow_pca_list
pca = PCA(n_components=1)
principalComponents1 = pca.fit_transform(flow_pca_list)
df1 = pd.DataFrame(data = principalComponents1)
flow_pca2 = df1[0].values.tolist()

# apply pca to time_matrix
pca = PCA(n_components=1)
principalComponents2 = pca.fit_transform(time_matrix)
df2 = pd.DataFrame(data = principalComponents2)
time_pca = df2[0].values.tolist()

features_list = []
features_list.append(flow_pca2)
features_list.append(time_pca)

## save features_list in txt
with open("sessions.txt","w") as file:
    file.write(str(features_list))
