import pandas as pd
import requests
import json
from pandas.io.json import json_normalize


# get page list
with open('C:/Users/heyu/PycharmProjects/newPageList.json') as jsonFile:
    pageTitles = json.load(jsonFile)  # read json file
df = pd.DataFrame(pageTitles)  # turn into dataframe
pageList = df['0'].values  # turn into list
#print(len(pageList))
#print(pageList)


# get visitor id list
baseurl = "https://empress.clai.io:1342/index.php?"
token = "&format=JSON&token_auth=92ff8605e20332d73e812cb23865a3bd"
module = "module=API&"
idSite = "1"  # don't change - there's only one page

method = "UserId.getUsers"

endpoint = baseurl + module + "method="+method+"&idSite="+idSite+"&period=range&date=2018-04-16,2018-05-20"+token
token = 'dXNlcjpaRHNFaDlaVGdiSzJ4cWE4Z1pFQnZnN1BQNGR1a0U='
headers = {"Authorization":"Basic " + token}
#print(endpoint)

data = pd.DataFrame(requests.get(endpoint,headers=headers).json())

# use visitor name and id to create a 2D list
Id = data['idvisitor'].values
name = data['label'].values
visitorId = [[0]*2 for a in range(len(Id))]
for i in range(len(Id)):
    visitorId[i] = [name[i],Id[i]]
print(visitorId)
print(len(visitorId))


# get each visitor's 10 sessions
baseurl = "https://empress.clai.io:1342/index.php?"
token = "&format=JSON&token_auth=92ff8605e20332d73e812cb23865a3bd"
module = "module=API&"
idSite = "1"  # don't change - there's only one page

method = "Live.getVisitorProfile"

endpoint = ['0'] * len(visitorId)
for i in range(len(visitorId)):
    endpoint[i] = baseurl + module + "method="+method+"&idSite="+idSite+"&visitorId="+visitorId[i][1]+"&period=range&date=2018-04-16,2018-05-20"+token
token = 'dXNlcjpaRHNFaDlaVGdiSzJ4cWE4Z1pFQnZnN1BQNGR1a0U='
headers = {"Authorization":"Basic " + token}
#print(endpoint)

big_matrix = [[0]*totalVisits for a in range(len(visitorId))]  # len(visitorId)*totalVisits
for x in endpoint:
    data_raw = requests.get(x,headers=headers).json()
# get visit logs for all sessions and put them into a 2D array
    lastVisits = data_raw['lastVisits']  # details of all sessions
    #print(lastVisits)
    totalVisits = data_raw['totalVisits']  # the number of sessions
    #print(totalVisits)
    if(totalVisits > 10):
        totalVisits = 10

    visitDetailNorm = [0] * totalVisits
    actionsNum = [0] * totalVisits
    userflow = []
    for i in range(totalVisits):
        visitDetailNorm[i] = json_normalize(lastVisits[i])  # normalize each session
        actionsNum[i] = visitDetailNorm[i]['actions']  # the number of urls visited in each session
        pageTitle = []
        for j in range(int(actionsNum[i])):
            pageTitle.append(visitDetailNorm[i]['actionDetails'][0][j]['url'])  # put urls in all sessions in one array
        userflow.append(pageTitle)  # form a 2D array on the base on the 1D arrays
    # remove prefix of each url
    substr1 = 'http://com.selfback'
    substr2 = 'http://selfback/screen'
    for a in range(totalVisits):
        for b in range(len(userflow[a])):
            #print(type(userflow[a][b]))
            if(substr1 in str(userflow[a][b])):
                index = userflow[a][b].find(substr1)
                userflow[a][b] = userflow[a][b][index+len(substr1):]
            elif(substr2 in str(userflow[a][b])):
                index = userflow[a][b].find(substr2)
                userflow[a][b] = userflow[a][b][index+len(substr2):]        

    #for a in range(totalVisits):
    #    print(userflow[a])
    #print(len(userflow))        

# put index of each page in each session in a 2D list
# get the max number of actions in all sessions
    max_actions = 0
    for i in range(totalVisits):
        if(int(actionsNum[i])>max_actions):
            max_actions = int(actionsNum[i])
    #print(max_actions)

# use the max_actions to initiate the index_list
    index_list = [[0]*max_actions for a in range(totalVisits)]  # index_list is totalVisits * len(each session) 2D list
    for m in pageList:
        for n in range(totalVisits):
            for p in range(len(userflow[n])):
                if(m == userflow[n][p]):
                    index1 = list(pageList).index(m)
                    index_list[n][p] = index1
    #print(index_list)
    #print(len(index_list))

# remove the unnecessary index 0
    for i in range(totalVisits):
        num_0 = max_actions - int(actionsNum[i])
        #print(num_0)
        for c in range(num_0):
            index_list[i].pop()
    #print(index_list)

# create a big matrix to put 10 matrix of each visitor
    user_index = endpoint.index(x)
    #print(user_index)
# create a 2D matrix for each session with the length of pageList and fill in 1s in the position referred by each index
    for i in range(totalVisits):
        flow_matrix = [[0]*len(pageList) for a in range(len(pageList))]  # flow_matrix is a 2D matrix with length of page list
# check if there is only 1 index in the index_list[i]
        if(len(index_list[i])==1):
            flow_matrix[index_list[i][0]][index_list[i][0]] = 1
        else:
            for j in range(len(index_list[i])-1):
                if(flow_matrix[index_list[i][j]][index_list[i][j+1]] > 0):
                    flow_matrix[index_list[i][j]][index_list[i][j+1]] += 1  # if there is 1 at the position already, increase it to 2, and so on.
                else:
                    flow_matrix[index_list[i][j]][index_list[i][j+1]] = 1  # if there is 0 at the position, increase it to 1
        #print(flow_matrix)
        big_matrix[user_index][i] = flow_matrix
#print(big_matrix[0][9])
print(len(big_matrix))


with open("bigMatrix.txt","w") as file:
    file.write(str(big_matrix))
