import pandas as pd
import requests
import matplotlib.pyplot as plt
import json
from pandas.io.json import json_normalize
import time
from datetime import date, datetime


baseurl = "https://empress.clai.io:1342/index.php?"
token = "&format=JSON&token_auth=92ff8605e20332d73e812cb23865a3bd"
module = "module=API&"
idSite = "1"  # don't change - there's only one page

#visitorId = "0852851164c0a96b" # trx_usertest_1, the shortest one
#visitorId = "4bb448a8dfff8f74"  # tfs_jorgen_07
#visitorId = "e845c1e717835152"  # kerstin
#visitorId = "5546b9ebe26a7051" # tfs_berit_05
visitorId = "62094dd800f813de"  # yu

method = "Live.getVisitorProfile"

endpoint = baseurl + module + "method="+method+"&idSite="+idSite+"&visitorId="+visitorId+"&period=year&date=2018-05-15"+"filter_limit=-1"+token
#endpoint = baseurl + module + "method="+method+"&idSite="+idSite+"&visitorId="+visitorId+"&period=range&date=2018-04-23,2018-05-13"+token
token = 'dXNlcjpaRHNFaDlaVGdiSzJ4cWE4Z1pFQnZnN1BQNGR1a0U='
headers = {"Authorization":"Basic " + token}
print(endpoint)

data_raw = requests.get(endpoint,headers=headers).json()
#print(data_raw)

# get visit logs for all sessions and put them into a 2D array
lastVisits = data_raw['lastVisits']  # details of all sessions
#print(lastVisits)
totalVisits = data_raw['totalVisits']  # the number of sessions
#print(totalVisits)

if(totalVisits > 10):
    totalVisits = 10  # only 10 sessions are available
    
visitDetailNorm = [0] * totalVisits
actionsNum = [0] * totalVisits
userflow = []
dateTime = []
dates = []
for i in range(totalVisits):
    visitDetailNorm[i] = json_normalize(lastVisits[i])  # normalize each session
    actionsNum[i] = visitDetailNorm[i]['actions']  # the number of urls visited in each session
    url = []
    for j in range(int(actionsNum[i])):
        url.append(visitDetailNorm[i]['actionDetails'][0][j]['url'])  # put urls in one session in one array
        dateTime.append(visitDetailNorm[i]['actionDetails'][0][j]['serverTimePretty'])
    userflow.append(url)  # form a 2D array on the base on the 1D arrays

for m in dateTime:
    # remove the comma
    datetime_ = m.replace(',','')
    # split the string by space
    dt_split = datetime_.split()
    #print(dt_split)
    
    # create a dictionary for months and format the number with padding 0
    month_dict = dict(Jan=1, Feb=2, Mar=3, Apr=4, May=5, Jun=6, Jul=7, Aug=8, Sep=9, Oct=10, Nov=11, Dec=12)
    months = list(month_dict.keys())
    #print(months)
    for i in month_dict:
        month_dict[i] = "{:02d}".format(month_dict[i])
    #print(month_dict)
    
    # turn months from words to numbers
    month_index = 0
    for i in months:
        if(dt_split[0] == i):
            month_num = month_dict[i]
    #print(month_num)
    new_dt_split = [month_num if x==dt_split[0] else x for x in dt_split]
    #print(new_dt_split)
    
    # reorder the string
    order = [2,0,1,3]
    new_dt = [new_dt_split[i] for i in order]
    #print(new_dt)

    # remove time from datetime. to calculate the days
    new_dt.pop()
    #print(new_dt)
    dates.append(new_dt)
#print(dates) 

# remove duplicate dates
clean_dates = []
[clean_dates.append(x) for x in dates if x not in clean_dates]
#print(clean_dates)

# to make datetime list. join the date string
dateList = []
for p in clean_dates:
    dt = int(''.join(p))
    #print(dt)
    dateList.append(datetime.strptime(str(dt), '%Y%m%d'))
print(dateList)

# calculate the days for 10 sessions
days = dateList[0] - dateList[len(dateList)-1]
print(days)
