import pandas as pd
import requests
import matplotlib.pyplot as plt
import matplotlib.patches as mpatches
import numpy as np


baseurl = "https://empress.clai.io:1342/index.php?"
token = "&format=JSON&token_auth=92ff8605e20332d73e812cb23865a3bd"
module = "module=API&"
idSite = "1"  # don't change - there's only one page

method = "Actions.getPageTitles"

endpoint = baseurl + module + "method="+method+"&idSite="+idSite+"&period=range&date=2018-04-23,2018-05-14"+token
token = 'dXNlcjpaRHNFaDlaVGdiSzJ4cWE4Z1pFQnZnN1BQNGR1a0U='
headers = {"Authorization":"Basic " + token}
print(endpoint)

data = pd.DataFrame(requests.get(endpoint,headers=headers).json())
data_filtered = data[['label','avg_time_on_page','nb_visits','sum_time_spent']]
data_filtered = data_filtered.iloc[3:]  # delete the first three row of "screen","page name not defined" and "Onboarding"
#data_filtered

label = data_filtered['label'].values
#avg_time = data_filtered['avg_time_on_page'].values
nb_visits = data_filtered['nb_visits'].values
#sum_time = data_filtered['sum_time_spent'].values


# multiple bar chart
plt.figure(figsize=(86,25))
x = np.arange(len(label))  # separate x axis according to the number of bars 
bar_width = 0.4
plt.bar(x, nb_visits, width=bar_width, color='b', align='center')

plt.xticks(x+bar_width/2,label)  # set labels for x axis
plt.title('Exercise Pages Visiting Frequency')

plt.grid(axis='y')  # set grid

plt.xlim([-0.3,x.size])  # shorten the white edge in the bar chart by setting the starting point of x axis

#plt.show()
plt.savefig('Exercise Pages Visiting Frequency.png')
