import pandas as pd
import requests
import matplotlib.pyplot as plt
import numpy as np


# get page title list
baseurl = "https://empress.clai.io:1342/index.php?"
token = "&format=JSON&token_auth=92ff8605e20332d73e812cb23865a3bd"
module = "module=API&"
idSite = "1"  # don't change - there's only one page

method1 = "Actions.getPageUrls"
endpoint1 = baseurl + module + "method="+method1+"&idSite="+idSite+"&period=year&date=today"+ token
token = 'dXNlcjpaRHNFaDlaVGdiSzJ4cWE4Z1pFQnZnN1BQNGR1a0U='
headers = {"Authorization":"Basic " + token}
#print(endpoint1)

data1 = pd.DataFrame(requests.get(endpoint1,headers=headers).json())

data1 = data1.sort_values(by=['label'])  # sort data according to alphabet of page titles
pageTitle = data1['label'].values.tolist()  # turn dataframe into list
pageTitle = [x for x in pageTitle if(x.find("selfback")==1)]  # only keep page titles containing selfback
print(pageTitle)


# get weekly visiting frequency of each page and make line chart to compare 
baseurl = "https://empress.clai.io:1342/index.php?"
token = "&format=JSON&token_auth=92ff8605e20332d73e812cb23865a3bd"
module = "module=API&"
idSite = "1"  # don't change - there's only one page

method2 = "Actions.getPageUrls"
week = ["2018-04-16,2018-04-22","2018-04-23,2018-04-29","2018-04-30,2018-05-06","2018-05-07,2018-05-13","2018-05-14,2018-05-20"]

# generate endpoint for each week
endpoint2 = ['0'] * len(week)
for i in range(len(week)):
    endpoint2[i] = baseurl + module + "method="+method2+"&idSite="+idSite+"&period=range"+"&date="+week[i]+ token
token = 'dXNlcjpaRHNFaDlaVGdiSzJ4cWE4Z1pFQnZnN1BQNGR1a0U='
headers = {"Authorization":"Basic " + token}
#print(endpoint2)

week_freq_pages = [[0]*len(week) for a in range(len(pageTitle))]  # each week for all pages, len(week)*len(pageTitle) 2D list. Need to check the max number of pages
#print(week_freq_pages)

# get 2D list for plot line chart
for x in endpoint2:
    label_freq = [[0]*2 for a in range(len(pageTitle))]
    data2 = pd.DataFrame(requests.get(x,headers=headers).json())
    data2 = data2.sort_values(by=['label'])  # set the way the data displayed. Now data is arranged according to label instead of nb_visits
    freq_value = data2['nb_visits'].values  # visiting frequency of each page title in each week
    #print(freq_value)
    page_label = data2['label'].values  # page titles visited in each week
    #print(page_label)
    
# make a 2D list with label and nb_visits
    for m in range(len(page_label)):
        label_freq[m] = [page_label[m],freq_value[m]]

# remove the sublists of 0
    num_0 = len(pageTitle) - len(page_label)
#    print(num_0)
    for c in range(num_0):
        label_freq.pop()
    #print(label_freq)
    
# make a 2D list with nb_visits and week
    for p in range(len(week)):
        if(x == endpoint2[p]):
            for i in range(len(pageTitle)):
                for j in range(len(label_freq)):
                    if(pageTitle[i] == label_freq[j][0]):
                        week_freq_pages[i][p] = label_freq[j][1]
#print(week_freq_pages)
#print(len(week_freq_pages))

# line chart
plt.figure(figsize=(12,12))
for y in range(len(pageTitle)):
    plt.plot(week,week_freq_pages[y],label=pageTitle[y])
plt.legend(bbox_to_anchor=(1.05,1),loc=2,borderaxespad=0.)
plt.xlabel('week')
plt.ylabel('nb_visits')
plt.title('Pages weekly frequency')

plt.show()
